/*
** Module   : AppServerFactory.java
** Abstract : A class for creating Server handles
**            attributes api.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- -----------------------Description------------------------
** 001 CS  20130211 Created initial version.
*/

package com.goldencode.p2j.util;

/**
 * A class for instantiating server handles.
 */
public class AppServerFactory
{
   // TODO implement PREV-SIBLING and NEXT-SIBLING handling when creating new sockets
   /**
    * Method for assigning a <code>SocketImpl</code> to the handle defining it 
    * as a socket.
    * 
    * @param serverHandle
    *        The handle to which we will assign the socket
    */
   public static void createServer(handle serverHandle)
   {
      serverHandle.assign(getNewServer());
   }

   /**
    * Method which returns a new ServerImpl.
    * 
    * @return a new ServerImpl as a WrappedResource.
    */
   private static WrappedResource getNewServer()
   {
      return new ServerImpl();
   }

}
