package com.goldencode.p2j.util;

/**
 * Interface for the FIRST-PROCEDURE and LAST-PROCEDURE attributes.
 * Exposes the following Attributes and methods:
 * <table>
 * <tr>
 *    <th>attribute or method</th>
 *    <th>API</th>
 * </tr>
 * <tr>
 *    <td>FIRST-PROCEDURE</td>
 *    <td>{@link #firstProcedure()}</td>
 * </tr>
 * <tr>
 *    <td>LAST-PROCEDURE</td>
 *    <td>{@link #lastProcedure()}</td>
 * </tr>
 * </table>
 * This is to be used by SERVER and SESSION handle implementations.
 */
public interface FirstLastProcedureAttribute
{
   /**
    * Returns the first entry in the list of persistent procedures or procedure objects.
    * 
    * @return see above.
    */
   public handle firstProcedure();
   
   /**
    * Returns the first entry in the list of persistent procedures or procedure objects.
    * 
    * @return see above.
    */
   public handle lastProcedure();
}
